#include <stdio.h>
#include <math.h>
#include <string.h>
#include <time.h>
#include <stdlib.h>
#include <unistd.h>
#include <pthread.h>
#include <sched.h>
#include <sys/stat.h>

int nothr;
char path[300];
long len;
long step;
unsigned char *buf;

void fload(long *ofs)
{
  FILE *f = fopen(path, "rb");
  fseek(f, 0, step*(*ofs));
  for(int i=0; i<step; i++)
    fread(buf+step*(*ofs)+i, 1, 1, f);

  fclose(f);
}

int main(int argc, char **argv)
{
  if(argc < 2)
  {
    printf("Usage:   fload <no threads> <filepath>\n");
    exit(0);
  }

  sscanf(argv[1], "%d", &nothr);
  sprintf(path, "%s", argv[2] );

  FILE *f = fopen(path, "rb");
  fseek(f, 0, SEEK_END);
  len = ftell(f);
  fclose(f);

  step = len/nothr;
  buf = new unsigned char[len];


  long *n;
  pthread_t eus[100];
  pthread_attr_t attr;
  pthread_attr_init(&attr);
  pthread_attr_setscope(&attr, PTHREAD_SCOPE_PROCESS);
  pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_JOINABLE);
  pthread_attr_setschedpolicy(&attr, SCHED_RR);
  timeval begin, end;
  double duration;

  gettimeofday(&begin, NULL);

  for(int i=0; i<nothr; i++)
  {
    n = new long;
    *n = i;
    pthread_create(&eus[i], &attr, 
                   (void *(*)(void *))fload, n);
  }
  for(int i=0; i< nothr; i++)
    pthread_join(eus[i], NULL);

  gettimeofday(&end, NULL);
  duration = end.tv_sec*1000*1000 + end.tv_usec - 
    begin.tv_sec*1000*1000 - begin.tv_usec;

  FILE * fbr = fopen(HOST, "ab");
  fprintf(fbr, "%d\t%f\n", nothr, (float)duration/1000.0f);
  fclose(fbr);
  delete []buf;

  return 1;
}


