#include "List.h"

/* ------------------------------------------------------------------------ */
AlphaItem::AlphaItem()
{
  min = 0.0f;
  max = 0.0f;
  alpha = 0.0f;
  Next = NULL;
  Prev = NULL;
}

/* ------------------------------------------------------------------------ */
RGBItem::RGBItem()
{
  min = 0.0f;
  max = 0.0f;
  rgb = new RGB();
  Next = NULL;
  Prev = NULL;
}

/* ------------------------------------------------------------------------ */
RGBItem::~RGBItem()
{
  if(rgb != NULL)
    delete rgb;
}

/* ------------------------------------------------------------------------ */
List::List()
{
  Head = NULL;
  Tail = NULL;
}

/* ------------------------------------------------------------------------ */
List::~List()
{
  ListItem *aux1, *aux2;

  aux1 = Head;

  while(aux1 != NULL) {
    aux2 = aux1->Next;
    delete(aux1);
    aux1 = aux2;
  }

  Head = NULL;
  Tail = NULL;
}

/* ------------------------------------------------------------------------ */
void List::clear()
{
  ListItem *aux1, *aux2;

  aux1 = Head;

  while(aux1 != NULL) {
    aux2 = aux1->Next;
    delete(aux1);
    aux1 = aux2;
  }

  Head = NULL;
  Tail = NULL;
}

/* ------------------------------------------------------------------------ */
void List::addToHead(ListItem *qi)
{
  if(qi == NULL)
    return;

  if(Tail == NULL)
  {
    Tail = qi;
    qi->Next = NULL;
    qi->Prev = NULL;
  }
  else
  {
    qi->Prev = NULL;
    qi->Next = Head;
    Head->Prev = qi;
  }

  Head = qi;
  qi->InList = this;
}

/* ------------------------------------------------------------------------ */
void List::addToTail(ListItem *qi)
{
  if(qi == NULL)
    return;

  if(Tail == NULL)
    addToHead(qi);
  else
  {
    Tail->Next = qi;
    qi->Next = NULL;
    qi->Prev = Tail;
    Tail = qi;
  }
  qi->InList = this;
}

/* ------------------------------------------------------------------------ */
void List::remove(ListItem *qi)
{
  if((qi != NULL) && (qi->InList == this))
  {
    if(qi == Head)
    {
      if(qi == Tail)
      {
        Head = NULL;
        Tail = NULL;
      }
      else
      {
        Head = qi->Next;
        Head->Prev = NULL;
      }
    }
    else
    {
      if(qi == Tail)
      {
        Tail = qi->Prev;
        Tail->Next = NULL;
      }
      else
      {
        qi->Prev->Next = qi->Next;
        qi->Next->Prev = qi->Prev;
      }
    }
	
    qi->Prev = NULL;
    qi->Next = NULL;
    qi->InList = NULL;
  }
}







































