#include "Defs.h"
#include "Rotation.h"

#ifndef POINT_H_INCLUDED
#define POINT_H_INCLUDED

class Transform;

class Point
{
public:
  float X, Y, Z;

  Point(Point *p);
  Point(float x = 0.0f, float y = 0.0f, float z = 0.0f);
  void init();
  void print();
  float dot(Point *p);
  float dist(Point *p);
  float dist(float x, float y, float z);
  float magnitude();
  int parallel(Point *p);
  void copy(Point *p);
  void copy(float x, float y, float z);

  void cross(Point *p);
  void add(Point *p);
  void sub(Point *p);
  void rot(Rotation *r);
  void trans(Transform *t);
  void scale(float s);
  void normalize();
  int greaterThan(Point *p);
  int lowerThan(Point *p);
};

#endif
