#include "Ray.h"

/* ------------------------------------------------------------------------ */
Ray::Ray(Point *p0, Point *p1, int dir)
{
  Point pdir;
  
  X0 = p0->X;
  Y0 = p0->Y;
  Z0 = p0->Z;

  if(dir)
  {
    pdir.copy(p1);
    pdir.normalize();
    Dx = pdir.X;
    Dy = pdir.Y;
    Dz = pdir.Z;
  }
  else
  {
    pdir.copy(p1->X - p0->X, p1->Y - p0->Y, p1->Z - p0->Z);
    pdir.normalize();
    Dx = pdir.X;
    Dy = pdir.Y;
    Dz = pdir.Z;
  }
}

/* ------------------------------------------------------------------------ */
void Ray::copy(Point *p0, Point *p1, int dir)
{
  Point pdir;
  
  X0 = p0->X;
  Y0 = p0->Y;
  Z0 = p0->Z;

  if(dir)
  {
    pdir.copy(p1);
    pdir.normalize();
    Dx = pdir.X;
    Dy = pdir.Y;
    Dz = pdir.Z;
  }
  else
  {
    pdir.copy(p1->X - p0->X, p1->Y - p0->Y, p1->Z - p0->Z);
    pdir.normalize();
    Dx = pdir.X;
    Dy = pdir.Y;
    Dz = pdir.Z;
  }
}

/* ------------------------------------------------------------------------ */
Ray::Ray(float x0, float dx, float y0, float dy, float z0, float dz)
{
  X0 = x0;
  Dx = dx;
  Y0 = y0;
  Dy = dy;
  Z0 = z0;
  Dz = dz;
}

/* ------------------------------------------------------------------------ */
void Ray::copy(float x0, float dx, float y0, float dy, 
                      float z0, float dz)
{
  X0 = x0;
  Dx = dx;
  Y0 = y0;
  Dy = dy;
  Z0 = z0;
  Dz = dz;
}

/* ------------------------------------------------------------------------ */
void Ray::getPoint(float t, Point *p)
{
  p->X = X0+t*Dx;
  p->Y = Y0+t*Dy;
  p->Z = Z0+t*Dz;
}
