#include "Rotation.h"

/* ------------------------------------------------------------------------ */
Rotation::Rotation(Rotation *r)
{
  int i, j;
  for(i=0; i<3; i++)
    for(j=0; j<3; j++)
      m[i][j] = r->m[i][j];
}

/* ------------------------------------------------------------------------ */
Rotation::Rotation(float buf[3][3])
{
  int i, j;
  for(i=0; i<3; i++)
    for(j=0; j<3; j++)
      m[i][j] = buf[i][j];
}

/* ------------------------------------------------------------------------ */
Rotation::Rotation()
{
  int i, j;
  for(i=0; i<3; i++)
    for(j=0; j<3; j++)
    {
      if(i != j)
        m[i][j] = 0.0f;
      else
        m[i][j] = 1.0f;
    }
  
}

/* ------------------------------------------------------------------------ */
void Rotation::copy(Rotation *r)
{
  int i, j;
  for(i=0; i<3; i++)
    for(j=0; j<3; j++)
      m[i][j] = r->m[i][j];
}

/* ------------------------------------------------------------------------ */
void Rotation::copy(float buf[3][3])
{
  int i, j;
  for(i=0; i<3; i++)
    for(j=0; j<3; j++)
      m[i][j] = buf[i][j];
}

/* ------------------------------------------------------------------------ */
void Rotation::scale(float f)
{
  int i, j;
  for(i=0; i<3; i++)
    for(j=0; j<3; j++)
      m[i][j] *= f;
}

/* ------------------------------------------------------------------------ */
void Rotation::invert()
{
  float buf[3][3];
  int i, j;

  for(i=0; i<3; i++)
    for(j=0; j<3; j++)
      buf[i][j] = m[j][i];

  for(i=0; i<3; i++)
    for(j=0; j<3; j++)
      m[i][j] = buf[i][j];
}

/* ------------------------------------------------------------------------ */
void Rotation::print()
{
  printf("%.3f   %.3f   %.3f\n", m[0][0], m[0][1], m[0][2]);
  printf("%.3f   %.3f   %.3f\n", m[1][0], m[1][1], m[1][2]);
  printf("%.3f   %.3f   %.3f\n", m[2][0], m[2][1], m[2][2]);
}

/* ------------------------------------------------------------------------ */
void Rotation::postMult(Rotation *r)
{
  int i, j;
  float aux[3][3];

  for(i=0; i<3; i++)
    for(j=0; j<3; j++)
      aux[i][j] = m[i][0]*r->m[0][j] + m[i][1]*r->m[1][j] + m[i][2]*r->m[2][j];

  for(i=0; i<3; i++)
    for(j=0; j<3; j++)
      m[i][j] = aux[i][j];
}

/* ------------------------------------------------------------------------ */
void Rotation::preMult(Rotation *r)
{
  int i, j;
  float aux[3][3];

  for(i=0; i<3; i++)
    for(j=0; j<3; j++)
      aux[i][j] = r->m[i][0]*m[0][j] + r->m[i][1]*m[1][j] + r->m[i][2]*m[2][j];

  for(i=0; i<3; i++)
    for(j=0; j<3; j++)
      m[i][j] = aux[i][j];
}

