#include "Renderer.h"
#include <sys/types.h>
#include <time.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>

float dist = 10;
float angle = 5;
Renderer *R;
char rot_axis='x';
int online = 1;
int frozen = 0;
char arg1[100];

/* ------------------------------------------------------------------------ */
void generateRotX(float alpha, Transform *t)
{
  float a, ca, sa;

  a = alpha/180.0f*3.14159f;
  ca = (float)cos(a);
  sa = (float)sin(a);

  t->m[0][0] = 1.0f;
  t->m[0][1] = 0.0f;
  t->m[0][2] = 0.0f;
  t->m[0][3] = 0.0f;
  t->m[1][0] = 0.0f;
  t->m[1][1] = ca;
  t->m[1][2] = -sa;
  t->m[1][3] = 0.0f;
  t->m[2][0] = 0.0f;
  t->m[2][1] = sa;
  t->m[2][2] = ca;
  t->m[2][3] = 0.0f;
  t->m[3][0] = 0.0f;
  t->m[3][1] = 0.0f;
  t->m[3][2] = 0.0f;;
  t->m[3][3] = 0.0f;
}

/* ------------------------------------------------------------------------ */
void generateRotY(float alpha, Transform *t)
{
  float a, ca, sa;

  a = alpha/180.0f*3.14159f;
  ca = (float)cos(a);
  sa = (float)sin(a);

  t->m[0][0] = ca;
  t->m[0][1] = 0.0f;
  t->m[0][2] = sa;
  t->m[0][3] = 0.0f;
  t->m[1][0] = 0.0f;
  t->m[1][1] = 1.0f;
  t->m[1][2] = 0.0f;
  t->m[1][3] = 0.0f;
  t->m[2][0] = -sa;
  t->m[2][1] = 0.0f;
  t->m[2][2] = ca;
  t->m[2][3] = 0.0f;
  t->m[3][0] = 0.0f;
  t->m[3][1] = 0.0f;
  t->m[3][2] = 0.0f;;
  t->m[3][3] = 0.0f;
}

/* ------------------------------------------------------------------------ */
void generateRotZ(float alpha, Transform *t)
{
  float a, ca, sa;

  a = alpha/180.0f*3.14159f;
  ca = (float)cos(a);
  sa = (float)sin(a);

  t->m[0][0] = ca;
  t->m[0][1] = -sa;
  t->m[0][2] = 0.0f;
  t->m[0][3] = 0.0f;
  t->m[1][0] = sa;
  t->m[1][1] = ca;
  t->m[1][2] = 0.0f;
  t->m[1][3] = 0.0f;
  t->m[2][0] = 0.0f;
  t->m[2][1] = 0.0f;
  t->m[2][2] = 1.0f;
  t->m[2][3] = 0.0f;
  t->m[3][0] = 0.0f;
  t->m[3][1] = 0.0f;
  t->m[3][2] = 0.0f;;
  t->m[3][3] = 0.0f;
}

/* ------------------------------------------------------------------------ */
void rotateVolumeN()
{
  Transform t, trans;
  FILE *fbr;

  while(R->FrameCount < 11)
  {
    switch(rot_axis)
    {
      case 'x':
        generateRotX(angle, &t);
        break;
      case 'y':
        generateRotY(angle, &t);
        break;
      case 'z':
        generateRotZ(angle, &t);
        break;
    };
    trans.copy(&R->T);
    trans.preMult(&t);
    R->setViewPlane(&trans);
    if(!online)
      break;
    R->render();
  }
  fbr = fopen("fbr", "ab");
  fprintf(fbr, "%f\n", R->AverageFrameDuration);
  fclose(fbr);
}

/* ------------------------------------------------------------------------ */
int main(int argc, char** argv)
{
  Point *dir, *vup, *last_dir;

  if(argc < 2)
  {
    printf("Usage:  vh <dataset base name>\n\n");
    exit(0);
  }

  strcpy(arg1, argv[1]);
  /* Initialize the renderer */
  R = new Renderer(argv[1]);
  last_dir = new Point(&R->INITDIR);
  dir = new Point(last_dir);
  vup = new Point();


  R->setHIPPosition(100.0f, 100.0f, 100.0f);
  R->setHIPVoxel(0, 0, 0);
  R->DS->avp.copy(1.0f, 1.0f, 1.0f);
  rotateVolumeN();
  delete R;
}
